<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>InsertUser</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>
<body>
    <div class="container jumbotron">
        <div class="text-center mb-4">
            <!--row 1-->
            <h3>Thêm mới User</h3>
        </div>
        <div class="row form-group">
            <div class="col-sm-4">
                <label>First name</label>
            </div>
            <div class="col-sm-8">
                <input class="form-control" placeholder="Nhap firstname" id="inp-firstname" type="text">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-4">
                <label>Last name</label>
            </div>
            <div class="col-sm-8">
                <input class="form-control" placeholder="Nhap lastname" id="inp-lastname" type="text">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-4">
                <label>Subject</label>
            </div>
            <div class="col-sm-8">
                <input class="form-control" placeholder="Nhap subject" id="inp-subject" type="text">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-4">
                <label>Country</label>
            </div>
            <div class="col-sm-8">
                <select class="form-control" id="select-country" name="Customertype">
                    <option value="VN">Viet Nam</option>
                    <option value="USA">USA</option>
                    <option value="AUS">Australia</option>
                    <option value="CAN">Canada</option>
                </select>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-4">
                <label>Customer Type</label>
            </div>
            <div class="col-sm-8">
                <select class="form-control" id="select-customerType" name="Customertype">
                    <option value="Standard">Standard</option>
                    <option value="Gold">Gold</option>
                    <option value="Premium">Premium</option>
                </select>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-4">
                <label>Register Status</label>
            </div>
            <div class="col-sm-8">
                <select class="form-control" id="select-register-status" name="registerStatus">
                    <option value="New">New</option>
                    <option value="Accepted">Accepted</option>
                    <option value="Denied">Denied</option>
                </select>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-4">
                <a id="btn-previous-page" class="btn btn-link" href="listUsers.html">Quay lại</a>
            </div>
            <div class="col-sm-8">
                <button type="button" class="btn btn-success" id="btn-insert-user">Insert User</button>
                
            </div>
        </div>
        
    </div>
</body>
</html>
<script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
        var gEleFirstName = $('#inp-firstname');
        var gEleLastName = $('#inp-lastname');
        var gEleCountry = $('#select-country');
        var gEleSubject = $('#inp-subject');
        var gEleCustomerType = $('#select-customerType');
        var gEleRegisterStatus = $('#select-register-status');

        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        $('#btn-insert-user').click(function(){
            console.log('Insert user click');
            //b1 get data
            var vDataObj = getFormData();
            console.log(vDataObj);
            //b2 validate
            var vIsDataValid = validateFormData(vDataObj);
            if(vIsDataValid){
                //b3 process insert user info
                callAjaxAPIInsertUser(vDataObj);
            }
        })
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        

        $(document).on("click","#btn-previous-page",function(){
            const vLIST_USER_URL = "listUser.html";
            var vUrlOpenSiter = vLIST_USER_URL ;
            window.location.href = vUrlOpenSiter;
        })
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

        function getFormData() {
            var vInsertInfoObj = new Object();
            vInsertInfoObj.firstname = $.trim(gEleFirstName.val());
            vInsertInfoObj.lastname = $.trim(gEleLastName.val());
            vInsertInfoObj.subject = $.trim(gEleSubject.val());
            vInsertInfoObj.country = $.trim(gEleCountry.val());
            vInsertInfoObj.customerType = $.trim(gEleCustomerType.val());
            vInsertInfoObj.registerStatus = $.trim(gEleRegisterStatus.val());
            return vInsertInfoObj;
            
        }
        function validateFormData(paramObjectUserData){
            if(paramObjectUserData.firstname == ""){
                alert("first name để trống");
                return false;
            }
            if(paramObjectUserData.lastname == ""){
                alert("last name để trống");
                return false;
            }
            if(paramObjectUserData.subject == ""){
                alert("subject để trống");
                return false;
            }
            if(paramObjectUserData.country == ""){
                alert("Country chưa chọn");
                return false;
            }
            if(paramObjectUserData.customerType == ""){
                alert("Customer Type chưa chọn");
                return false;
            }
            if(paramObjectUserData.registerStatus == ""){
                alert("Register Status chưa chọn");
                return false;
            }
            return true;
        }
        function callAjaxAPIInsertUser(paramDataInsertObj){
            var vJSONString = JSON.stringify(paramDataInsertObj);
            $.ajax({
                url: gBASE_URL,
                method : 'POST',
                data : vJSONString,
                contentType: "application/json; charset = utf-8",
                success : function(paramResponse){
                    alert("user ID: " + paramResponse.id + "Tạo thành công");
                    window.location.href = "listUsers.html";
                    console.log(JSON.stringify(paramResponse,true,2));
                },
                error : function(ajaxContext){
                    console.log(ajaxContext);
                } 
            });
        }
        
</script>